]> CyberLeo.Net >> Repos - FreeBSD/stable/10.git/blob - etc/rc.subr
MFC r324312: fix the misleading log facility used in devd/zfs.conf
[FreeBSD/stable/10.git] / etc / rc.subr
1 # $NetBSD: rc.subr,v 1.67 2006/10/07 11:25:15 elad Exp $
2 # $FreeBSD$
3 #
4 # Copyright (c) 1997-2004 The NetBSD Foundation, Inc.
5 # All rights reserved.
6 #
7 # This code is derived from software contributed to The NetBSD Foundation
8 # by Luke Mewburn.
9 #
10 # Redistribution and use in source and binary forms, with or without
11 # modification, are permitted provided that the following conditions
12 # are met:
13 # 1. Redistributions of source code must retain the above copyright
14 #    notice, this list of conditions and the following disclaimer.
15 # 2. Redistributions in binary form must reproduce the above copyright
16 #    notice, this list of conditions and the following disclaimer in the
17 #    documentation and/or other materials provided with the distribution.
18 #
19 # THIS SOFTWARE IS PROVIDED BY THE NETBSD FOUNDATION, INC. AND CONTRIBUTORS
20 # ``AS IS'' AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED
21 # TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR
22 # PURPOSE ARE DISCLAIMED.  IN NO EVENT SHALL THE FOUNDATION OR CONTRIBUTORS
23 # BE LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR
24 # CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF
25 # SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
26 # INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN
27 # CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)
28 # ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
29 # POSSIBILITY OF SUCH DAMAGE.
30 #
31 # rc.subr
32 #       functions used by various rc scripts
33 #
34
35 : ${RC_PID:=$$}; export RC_PID
36
37 #
38 #       Operating System dependent/independent variables
39 #
40
41 if [ -z "${_rc_subr_loaded}" ]; then
42
43 _rc_subr_loaded="YES"
44
45 SYSCTL="/sbin/sysctl"
46 SYSCTL_N="${SYSCTL} -n"
47 SYSCTL_W="${SYSCTL}"
48 ID="/usr/bin/id"
49 IDCMD="if [ -x $ID ]; then $ID -un; fi"
50 PS="/bin/ps -ww"
51 JID=`$PS -p $$ -o jid=`
52
53 #
54 #       functions
55 #       ---------
56
57 # list_vars pattern
58 #       List vars matching pattern.
59
60 list_vars()
61 {
62         set | { while read LINE; do
63                 var="${LINE%%=*}"
64                 case "$var" in
65                 "$LINE"|*[!a-zA-Z0-9_]*) continue ;;
66                 $1) echo $var
67                 esac
68         done; }
69 }
70
71 # set_rcvar [var] [defval] [desc]
72 #
73 #       Echo or define a rc.conf(5) variable name.  Global variable
74 #       $rcvars is used.
75 #
76 #       If no argument is specified, echo "${name}_enable".
77 #
78 #       If only a var is specified, echo "${var}_enable".
79 #
80 #       If var and defval are specified, the ${var} is defined as
81 #       rc.conf(5) variable and the default value is ${defvar}.  An
82 #       optional argument $desc can also be specified to add a
83 #       description for that.
84 #
85 set_rcvar()
86 {
87         local _var
88
89         case $# in
90         0)      echo ${name}_enable ;;
91         1)      echo ${1}_enable ;;
92         *)
93                 debug "set_rcvar: \$$1=$2 is added" \
94                     " as a rc.conf(5) variable."
95                 _var=$1
96                 rcvars="${rcvars# } $_var"
97                 eval ${_var}_defval=\"$2\"
98                 shift 2
99                 eval ${_var}_desc=\"$*\"
100         ;;
101         esac
102 }
103
104 # set_rcvar_obsolete oldvar [newvar] [msg]
105 #       Define obsolete variable.
106 #       Global variable $rcvars_obsolete is used.
107 #
108 set_rcvar_obsolete()
109 {
110         local _var
111         _var=$1
112         debug "set_rcvar_obsolete: \$$1(old) -> \$$2(new) is defined"
113
114         rcvars_obsolete="${rcvars_obsolete# } $1"
115         eval ${1}_newvar=\"$2\"
116         shift 2
117         eval ${_var}_obsolete_msg=\"$*\"
118 }
119
120 #
121 # force_depend script [rcvar]
122 #       Force a service to start. Intended for use by services
123 #       to resolve dependency issues.
124 #       $1 - filename of script, in /etc/rc.d, to run
125 #       $2 - name of the script's rcvar (minus the _enable)
126 #
127 force_depend()
128 {
129         local _depend _dep_rcvar
130
131         _depend="$1"
132         _dep_rcvar="${2:-$1}_enable"
133
134         [ -n "$rc_fast" ] && ! checkyesno always_force_depends &&
135             checkyesno $_dep_rcvar && return 0
136
137         /etc/rc.d/${_depend} forcestatus >/dev/null 2>&1 && return 0
138
139         info "${name} depends on ${_depend}, which will be forced to start."
140         if ! /etc/rc.d/${_depend} forcestart; then
141                 warn "Unable to force ${_depend}. It may already be running."
142                 return 1
143         fi
144 }
145
146 #
147 # checkyesno var
148 #       Test $1 variable, and warn if not set to YES or NO.
149 #       Return 0 if it's "yes" (et al), nonzero otherwise.
150 #
151 checkyesno()
152 {
153         eval _value=\$${1}
154         debug "checkyesno: $1 is set to $_value."
155         case $_value in
156
157                 #       "yes", "true", "on", or "1"
158         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
159                 return 0
160                 ;;
161
162                 #       "no", "false", "off", or "0"
163         [Nn][Oo]|[Ff][Aa][Ll][Ss][Ee]|[Oo][Ff][Ff]|0)
164                 return 1
165                 ;;
166         *)
167                 warn "\$${1} is not set properly - see rc.conf(5)."
168                 return 1
169                 ;;
170         esac
171 }
172
173 #
174 # reverse_list list
175 #       print the list in reverse order
176 #
177 reverse_list()
178 {
179         _revlist=
180         for _revfile; do
181                 _revlist="$_revfile $_revlist"
182         done
183         echo $_revlist
184 }
185
186 # stop_boot always
187 #       If booting directly to multiuser or $always is enabled,
188 #       send SIGTERM to the parent (/etc/rc) to abort the boot.
189 #       Otherwise just exit.
190 #
191 stop_boot()
192 {
193         local always
194
195         case $1 in
196                 #       "yes", "true", "on", or "1"
197         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
198                 always=true
199                 ;;
200         *)
201                 always=false
202                 ;;
203         esac
204         if [ "$autoboot" = yes -o "$always" = true ]; then
205                 echo "ERROR: ABORTING BOOT (sending SIGTERM to parent)!"
206                 kill -TERM ${RC_PID}
207         fi
208         exit 1
209 }
210
211 #
212 # mount_critical_filesystems type
213 #       Go through the list of critical filesystems as provided in
214 #       the rc.conf(5) variable $critical_filesystems_${type}, checking
215 #       each one to see if it is mounted, and if it is not, mounting it.
216 #
217 mount_critical_filesystems()
218 {
219         eval _fslist=\$critical_filesystems_${1}
220         for _fs in $_fslist; do
221                 mount | (
222                         _ismounted=false
223                         while read what _on on _type type; do
224                                 if [ $on = $_fs ]; then
225                                         _ismounted=true
226                                 fi
227                         done
228                         if $_ismounted; then
229                                 :
230                         else
231                                 mount $_fs >/dev/null 2>&1
232                         fi
233                 )
234         done
235 }
236
237 #
238 # check_pidfile pidfile procname [interpreter]
239 #       Parses the first line of pidfile for a PID, and ensures
240 #       that the process is running and matches procname.
241 #       Prints the matching PID upon success, nothing otherwise.
242 #       interpreter is optional; see _find_processes() for details.
243 #
244 check_pidfile()
245 {
246         _pidfile=$1
247         _procname=$2
248         _interpreter=$3
249         if [ -z "$_pidfile" -o -z "$_procname" ]; then
250                 err 3 'USAGE: check_pidfile pidfile procname [interpreter]'
251         fi
252         if [ ! -f $_pidfile ]; then
253                 debug "pid file ($_pidfile): not readable."
254                 return
255         fi
256         read _pid _junk < $_pidfile
257         if [ -z "$_pid" ]; then
258                 debug "pid file ($_pidfile): no pid in file."
259                 return
260         fi
261         _find_processes $_procname ${_interpreter:-.} '-p '"$_pid"
262 }
263
264 #
265 # check_process procname [interpreter]
266 #       Ensures that a process (or processes) named procname is running.
267 #       Prints a list of matching PIDs.
268 #       interpreter is optional; see _find_processes() for details.
269 #
270 check_process()
271 {
272         _procname=$1
273         _interpreter=$2
274         if [ -z "$_procname" ]; then
275                 err 3 'USAGE: check_process procname [interpreter]'
276         fi
277         _find_processes $_procname ${_interpreter:-.} '-ax'
278 }
279
280 #
281 # _find_processes procname interpreter psargs
282 #       Search for procname in the output of ps generated by psargs.
283 #       Prints the PIDs of any matching processes, space separated.
284 #
285 #       If interpreter == ".", check the following variations of procname
286 #       against the first word of each command:
287 #               procname
288 #               `basename procname`
289 #               `basename procname` + ":"
290 #               "(" + `basename procname` + ")"
291 #               "[" + `basename procname` + "]"
292 #
293 #       If interpreter != ".", read the first line of procname, remove the
294 #       leading #!, normalise whitespace, append procname, and attempt to
295 #       match that against each command, either as is, or with extra words
296 #       at the end.  As an alternative, to deal with interpreted daemons
297 #       using perl, the basename of the interpreter plus a colon is also
298 #       tried as the prefix to procname.
299 #
300 _find_processes()
301 {
302         if [ $# -ne 3 ]; then
303                 err 3 'USAGE: _find_processes procname interpreter psargs'
304         fi
305         _procname=$1
306         _interpreter=$2
307         _psargs=$3
308
309         _pref=
310         if [ $_interpreter != "." ]; then       # an interpreted script
311                 _script="${_chroot}${_chroot:+/}$_procname"
312                 if [ -r "$_script" ]; then
313                         read _interp < $_script # read interpreter name
314                         case "$_interp" in
315                         \#!*)
316                                 _interp=${_interp#\#!}  # strip #!
317                                 set -- $_interp
318                                 case $1 in
319                                 */bin/env)
320                                         shift   # drop env to get real name
321                                         ;;
322                                 esac
323                                 if [ $_interpreter != $1 ]; then
324                                         warn "\$command_interpreter $_interpreter != $1"
325                                 fi
326                                 ;;
327                         *)
328                                 warn "no shebang line in $_script"
329                                 set -- $_interpreter
330                                 ;;
331                         esac
332                 else
333                         warn "cannot read shebang line from $_script"
334                         set -- $_interpreter
335                 fi
336                 _interp="$* $_procname"         # cleanup spaces, add _procname
337                 _interpbn=${1##*/}
338                 _fp_args='_argv'
339                 _fp_match='case "$_argv" in
340                     ${_interp}|"${_interp} "*|"[${_interpbn}]"|"${_interpbn}: ${_procname}"*)'
341         else                                    # a normal daemon
342                 _procnamebn=${_procname##*/}
343                 _fp_args='_arg0 _argv'
344                 _fp_match='case "$_arg0" in
345                     $_procname|$_procnamebn|${_procnamebn}:|"(${_procnamebn})"|"[${_procnamebn}]")'
346         fi
347
348         _proccheck="\
349                 $PS 2>/dev/null -o pid= -o jid= -o command= $_psargs"' |
350                 while read _npid _jid '"$_fp_args"'; do
351                         '"$_fp_match"'
352                                 if [ "$JID" -eq "$_jid" ];
353                                 then echo -n "$_pref$_npid";
354                                 _pref=" ";
355                                 fi
356                                 ;;
357                         esac
358                 done'
359
360 #       debug "in _find_processes: proccheck is ($_proccheck)."
361         eval $_proccheck
362 }
363
364 # sort_lite [-b] [-n] [-k POS] [-t SEP]
365 #       A lite version of sort(1) (supporting a few options) that can be used
366 #       before the real sort(1) is available (e.g., in scripts that run prior
367 #       to mountcritremote). Requires only shell built-in functionality.
368 #
369 sort_lite()
370 {
371         local funcname=sort_lite
372         local sort_sep="$IFS" sort_ignore_leading_space=
373         local sort_field=0 sort_strict_fields= sort_numeric=
374         local nitems=0 skip_leading=0 trim=
375
376         local OPTIND flag
377         while getopts bnk:t: flag; do
378                 case "$flag" in
379                 b) sort_ignore_leading_space=1 ;;
380                 n) sort_numeric=1 sort_ignore_leading_space=1 ;;
381                 k) sort_field="${OPTARG%%,*}" ;; # only up to first comma
382                         # NB: Unlike sort(1) only one POS allowed
383                 t) sort_sep="$OPTARG"
384                    if [ ${#sort_sep} -gt 1 ]; then
385                         echo "$funcname: multi-character tab \`$sort_sep'" >&2
386                         return 1
387                    fi
388                    sort_strict_fields=1
389                    ;;
390                 \?) return 1 ;;
391                 esac
392         done
393         shift $(( $OPTIND - 1 ))
394
395         # Create transformation pattern to trim leading text if desired
396         case "$sort_field" in
397         ""|[!0-9]*|*[!0-9.]*)
398                 echo "$funcname: invalid sort field \`$sort_field'" >&2
399                 return 1
400                 ;;
401         *.*)
402                 skip_leading=${sort_field#*.} sort_field=${sort_field%%.*}
403                 while [ ${skip_leading:-0} -gt 1 ] 2> /dev/null; do
404                         trim="$trim?" skip_leading=$(( $skip_leading - 1 ))
405                 done
406         esac
407
408         # Copy input to series of local numbered variables
409         # NB: IFS of NULL preserves leading whitespace
410         local LINE
411         while IFS= read -r LINE || [ "$LINE" ]; do
412                 nitems=$(( $nitems + 1 ))
413                 local src_$nitems="$LINE"
414         done
415
416         #
417         # Sort numbered locals using insertion sort
418         #
419         local curitem curitem_orig curitem_mod curitem_haskey
420         local dest dest_orig dest_mod dest_haskey
421         local d gt n
422         local i=1 
423         while [ $i -le $nitems ]; do
424                 curitem_haskey=1 # Assume sort field (-k POS) exists
425                 eval curitem=\"\$src_$i\"
426                 curitem_mod="$curitem" # for modified comparison
427                 curitem_orig="$curitem" # for original comparison
428
429                 # Trim leading whitespace if desired
430                 if [ "$sort_ignore_leading_space" ]; then
431                         while case "$curitem_orig" in
432                                 [$IFS]*) : ;; *) false; esac
433                         do
434                                 curitem_orig="${curitem_orig#?}"
435                         done
436                         curitem_mod="$curitem_orig"
437                 fi
438
439                 # Shift modified comparison value if sort field (-k POS) is > 1
440                 n=$sort_field
441                 while [ $n -gt 1 ]; do
442                         case "$curitem_mod" in
443                         *[$sort_sep]*)
444                                 # Cut text up-to (and incl.) first separator
445                                 curitem_mod="${curitem_mod#*[$sort_sep]}"
446
447                                 # Skip NULLs unless strict field splitting
448                                 [ "$sort_strict_fields" ] ||
449                                         [ "${curitem_mod%%[$sort_sep]*}" ] ||
450                                         [ $n -eq 2 ] ||
451                                         continue
452                                 ;;
453                         *)
454                                 # Asked for a field that doesn't exist
455                                 curitem_haskey= break
456                         esac
457                         n=$(( $n - 1 ))
458                 done
459
460                 # Trim trailing words if sort field >= 1
461                 [ $sort_field -ge 1 -a "$sort_numeric" ] &&
462                         curitem_mod="${curitem_mod%%[$sort_sep]*}"
463
464                 # Apply optional trim (-k POS.TRIM) to cut leading characters
465                 curitem_mod="${curitem_mod#$trim}"
466
467                 # Determine the type of modified comparison to use initially
468                 # NB: Prefer numerical if requested but fallback to standard
469                 case "$curitem_mod" in
470                 ""|[!0-9]*) # NULL or begins with non-number
471                         gt=">"
472                         [ "$sort_numeric" ] && curitem_mod=0
473                         ;;
474                 *)
475                         if [ "$sort_numeric" ]; then
476                                 gt="-gt"
477                                 curitem_mod="${curitem_mod%%[!0-9]*}"
478                                         # NB: trailing non-digits removed
479                                         # otherwise numeric comparison fails
480                         else
481                                 gt=">"
482                         fi
483                 esac
484
485                 # If first time through, short-circuit below position-search
486                 if [ $i -le 1 ]; then
487                         d=0
488                 else
489                         d=1
490                 fi
491
492                 #
493                 # Find appropriate element position
494                 #
495                 while [ $d -gt 0 ]
496                 do
497                         dest_haskey=$curitem_haskey
498                         eval dest=\"\$dest_$d\"
499                         dest_mod="$dest" # for modified comparison
500                         dest_orig="$dest" # for original comparison
501
502                         # Trim leading whitespace if desired
503                         if [ "$sort_ignore_leading_space" ]; then
504                                 while case "$dest_orig" in
505                                         [$IFS]*) : ;; *) false; esac
506                                 do
507                                         dest_orig="${dest_orig#?}"
508                                 done
509                                 dest_mod="$dest_orig"
510                         fi
511
512                         # Shift modified value if sort field (-k POS) is > 1
513                         n=$sort_field
514                         while [ $n -gt 1 ]; do
515                                 case "$dest_mod" in
516                                 *[$sort_sep]*)
517                                         # Cut text up-to (and incl.) 1st sep
518                                         dest_mod="${dest_mod#*[$sort_sep]}"
519
520                                         # Skip NULLs unless strict fields
521                                         [ "$sort_strict_fields" ] ||
522                                             [ "${dest_mod%%[$sort_sep]*}" ] ||
523                                             [ $n -eq 2 ] ||
524                                             continue
525                                         ;;
526                                 *)
527                                         # Asked for a field that doesn't exist
528                                         dest_haskey= break
529                                 esac
530                                 n=$(( $n - 1 ))
531                         done
532
533                         # Trim trailing words if sort field >= 1
534                         [ $sort_field -ge 1 -a "$sort_numeric" ] &&
535                                 dest_mod="${dest_mod%%[$sort_sep]*}"
536
537                         # Apply optional trim (-k POS.TRIM), cut leading chars
538                         dest_mod="${dest_mod#$trim}"
539
540                         # Determine type of modified comparison to use
541                         # NB: Prefer numerical if requested, fallback to std
542                         case "$dest_mod" in
543                         ""|[!0-9]*) # NULL or begins with non-number
544                                 gt=">"
545                                 [ "$sort_numeric" ] && dest_mod=0
546                                 ;;
547                         *)
548                                 if [ "$sort_numeric" ]; then
549                                         gt="-gt"
550                                         dest_mod="${dest_mod%%[!0-9]*}"
551                                                 # NB: kill trailing non-digits
552                                                 # for numeric comparison safety
553                                 else
554                                         gt=">"
555                                 fi
556                         esac
557
558                         # Break if we've found the proper element position
559                         if [ "$curitem_haskey" -a "$dest_haskey" ]; then
560                                 if [ "$dest_mod" = "$curitem_mod" ]; then
561                                         [ "$dest_orig" ">" "$curitem_orig" ] &&
562                                                 break
563                                 elif [ "$dest_mod" $gt "$curitem_mod" ] \
564                                         2> /dev/null
565                                 then
566                                         break
567                                 fi
568                         else
569                                 [ "$dest_orig" ">" "$curitem_orig" ] && break
570                         fi
571
572                         # Break if we've hit the end
573                         [ $d -ge $i ] && break
574
575                         d=$(( $d + 1 ))
576                 done
577
578                 # Shift remaining positions forward, making room for new item
579                 n=$i
580                 while [ $n -ge $d ]; do
581                         # Shift destination item forward one placement
582                         eval dest_$(( $n + 1 ))=\"\$dest_$n\"
583                         n=$(( $n - 1 ))
584                 done
585
586                 # Place the element
587                 if [ $i -eq 1 ]; then
588                         local dest_1="$curitem"
589                 else
590                         local dest_$d="$curitem"
591                 fi
592
593                 i=$(( $i + 1 ))
594         done
595
596         # Print sorted results
597         d=1
598         while [ $d -le $nitems ]; do
599                 eval echo \"\$dest_$d\"
600                 d=$(( $d + 1 ))
601         done
602 }
603
604 #
605 # wait_for_pids pid [pid ...]
606 #       spins until none of the pids exist
607 #
608 wait_for_pids()
609 {
610         local _list _prefix _nlist _j
611
612         _list="$@"
613         if [ -z "$_list" ]; then
614                 return
615         fi
616         _prefix=
617         while true; do
618                 _nlist="";
619                 for _j in $_list; do
620                         if kill -0 $_j 2>/dev/null; then
621                                 _nlist="${_nlist}${_nlist:+ }$_j"
622                                 [ -n "$_prefix" ] && sleep 1
623                         fi
624                 done
625                 if [ -z "$_nlist" ]; then
626                         break
627                 fi
628                 _list=$_nlist
629                 echo -n ${_prefix:-"Waiting for PIDS: "}$_list
630                 _prefix=", "
631                 pwait $_list 2>/dev/null
632         done
633         if [ -n "$_prefix" ]; then
634                 echo "."
635         fi
636 }
637
638 #
639 # get_pidfile_from_conf string file
640 #
641 #       Takes a string to search for in the specified file.
642 #       Ignores lines with traditional comment characters.
643 #
644 # Example:
645 #
646 # if get_pidfile_from_conf string file; then
647 #       pidfile="$_pidfile_from_conf"
648 # else
649 #       pidfile='appropriate default'
650 # fi
651 #
652 get_pidfile_from_conf()
653 {
654         if [ -z "$1" -o -z "$2" ]; then
655                 err 3 "USAGE: get_pidfile_from_conf string file ($name)"
656         fi
657
658         local string file line
659
660         string="$1" ; file="$2"
661
662         if [ ! -s "$file" ]; then
663                 err 3 "get_pidfile_from_conf: $file does not exist ($name)"
664         fi
665
666         while read line; do
667                 case "$line" in
668                 *[#\;]*${string}*)      continue ;;
669                 *${string}*)            break ;;
670                 esac
671         done < $file
672
673         if [ -n "$line" ]; then
674                 line=${line#*/}
675                 _pidfile_from_conf="/${line%%[\"\;]*}"
676         else
677                 return 1
678         fi
679 }
680
681 #
682 # check_startmsgs
683 #       If rc_quiet is set (usually as a result of using faststart at
684 #       boot time) check if rc_startmsgs is enabled.
685 #
686 check_startmsgs()
687 {
688         if [ -n "$rc_quiet" ]; then
689                 checkyesno rc_startmsgs
690         else
691                 return 0
692         fi
693 }
694
695 #
696 # run_rc_command argument
697 #       Search for argument in the list of supported commands, which is:
698 #               "start stop restart rcvar status poll ${extra_commands}"
699 #       If there's a match, run ${argument}_cmd or the default method
700 #       (see below).
701 #
702 #       If argument has a given prefix, then change the operation as follows:
703 #               Prefix  Operation
704 #               ------  ---------
705 #               fast    Skip the pid check, and set rc_fast=yes, rc_quiet=yes
706 #               force   Set ${rcvar} to YES, and set rc_force=yes
707 #               one     Set ${rcvar} to YES
708 #               quiet   Don't output some diagnostics, and set rc_quiet=yes
709 #
710 #       The following globals are used:
711 #
712 #       Name            Needed  Purpose
713 #       ----            ------  -------
714 #       name            y       Name of script.
715 #
716 #       command         n       Full path to command.
717 #                               Not needed if ${rc_arg}_cmd is set for
718 #                               each keyword.
719 #
720 #       command_args    n       Optional args/shell directives for command.
721 #
722 #       command_interpreter n   If not empty, command is interpreted, so
723 #                               call check_{pidfile,process}() appropriately.
724 #
725 #       desc            n       Description of script.
726 #
727 #       extra_commands  n       List of extra commands supported.
728 #
729 #       pidfile         n       If set, use check_pidfile $pidfile $command,
730 #                               otherwise use check_process $command.
731 #                               In either case, only check if $command is set.
732 #
733 #       procname        n       Process name to check for instead of $command.
734 #
735 #       rcvar           n       This is checked with checkyesno to determine
736 #                               if the action should be run.
737 #
738 #       ${name}_program n       Full path to command.
739 #                               Meant to be used in /etc/rc.conf to override
740 #                               ${command}.
741 #
742 #       ${name}_chroot  n       Directory to chroot to before running ${command}
743 #                               Requires /usr to be mounted.
744 #
745 #       ${name}_chdir   n       Directory to cd to before running ${command}
746 #                               (if not using ${name}_chroot).
747 #
748 #       ${name}_flags   n       Arguments to call ${command} with.
749 #                               NOTE:   $flags from the parent environment
750 #                                       can be used to override this.
751 #
752 #       ${name}_env     n       Environment variables to run ${command} with.
753 #
754 #       ${name}_fib     n       Routing table number to run ${command} with.
755 #
756 #       ${name}_nice    n       Nice level to run ${command} at.
757 #
758 #       ${name}_user    n       User to run ${command} as, using su(1) if not
759 #                               using ${name}_chroot.
760 #                               Requires /usr to be mounted.
761 #
762 #       ${name}_group   n       Group to run chrooted ${command} as.
763 #                               Requires /usr to be mounted.
764 #
765 #       ${name}_groups  n       Comma separated list of supplementary groups
766 #                               to run the chrooted ${command} with.
767 #                               Requires /usr to be mounted.
768 #
769 #       ${name}_prepend n       Command added before ${command}.
770 #
771 #       ${rc_arg}_cmd   n       If set, use this as the method when invoked;
772 #                               Otherwise, use default command (see below)
773 #
774 #       ${rc_arg}_precmd n      If set, run just before performing the
775 #                               ${rc_arg}_cmd method in the default
776 #                               operation (i.e, after checking for required
777 #                               bits and process (non)existence).
778 #                               If this completes with a non-zero exit code,
779 #                               don't run ${rc_arg}_cmd.
780 #
781 #       ${rc_arg}_postcmd n     If set, run just after performing the
782 #                               ${rc_arg}_cmd method, if that method
783 #                               returned a zero exit code.
784 #
785 #       required_dirs   n       If set, check for the existence of the given
786 #                               directories before running a (re)start command.
787 #
788 #       required_files  n       If set, check for the readability of the given
789 #                               files before running a (re)start command.
790 #
791 #       required_modules n      If set, ensure the given kernel modules are
792 #                               loaded before running a (re)start command.
793 #                               The check and possible loads are actually
794 #                               done after start_precmd so that the modules
795 #                               aren't loaded in vain, should the precmd
796 #                               return a non-zero status to indicate a error.
797 #                               If a word in the list looks like "foo:bar",
798 #                               "foo" is the KLD file name and "bar" is the
799 #                               module name.  If a word looks like "foo~bar",
800 #                               "foo" is the KLD file name and "bar" is a
801 #                               egrep(1) pattern matching the module name.
802 #                               Otherwise the module name is assumed to be
803 #                               the same as the KLD file name, which is most
804 #                               common.  See load_kld().
805 #
806 #       required_vars   n       If set, perform checkyesno on each of the
807 #                               listed variables before running the default
808 #                               (re)start command.
809 #
810 #       Default behaviour for a given argument, if no override method is
811 #       provided:
812 #
813 #       Argument        Default behaviour
814 #       --------        -----------------
815 #       start           if !running && checkyesno ${rcvar}
816 #                               ${command}
817 #
818 #       stop            if ${pidfile}
819 #                               rc_pid=$(check_pidfile $pidfile $command)
820 #                       else
821 #                               rc_pid=$(check_process $command)
822 #                       kill $sig_stop $rc_pid
823 #                       wait_for_pids $rc_pid
824 #                       ($sig_stop defaults to TERM.)
825 #
826 #       reload          Similar to stop, except use $sig_reload instead,
827 #                       and doesn't wait_for_pids.
828 #                       $sig_reload defaults to HUP.
829 #                       Note that `reload' isn't provided by default,
830 #                       it should be enabled via $extra_commands.
831 #
832 #       restart         Run `stop' then `start'.
833 #
834 #       status          Show if ${command} is running, etc.
835 #
836 #       poll            Wait for ${command} to exit.
837 #
838 #       rcvar           Display what rc.conf variable is used (if any).
839 #
840 #       enabled         Return true if the service is enabled.
841 #
842 #       Variables available to methods, and after run_rc_command() has
843 #       completed:
844 #
845 #       Variable        Purpose
846 #       --------        -------
847 #       rc_arg          Argument to command, after fast/force/one processing
848 #                       performed
849 #
850 #       rc_flags        Flags to start the default command with.
851 #                       Defaults to ${name}_flags, unless overridden
852 #                       by $flags from the environment.
853 #                       This variable may be changed by the precmd method.
854 #
855 #       rc_pid          PID of command (if appropriate)
856 #
857 #       rc_fast         Not empty if "fast" was provided (q.v.)
858 #
859 #       rc_force        Not empty if "force" was provided (q.v.)
860 #
861 #       rc_quiet        Not empty if "quiet" was provided
862 #
863 #
864 run_rc_command()
865 {
866         _return=0
867         rc_arg=$1
868         if [ -z "$name" ]; then
869                 err 3 'run_rc_command: $name is not set.'
870         fi
871
872         # Don't repeat the first argument when passing additional command-
873         # line arguments to the command subroutines.
874         #
875         shift 1
876         rc_extra_args="$*"
877
878         _rc_prefix=
879         case "$rc_arg" in
880         fast*)                          # "fast" prefix; don't check pid
881                 rc_arg=${rc_arg#fast}
882                 rc_fast=yes
883                 rc_quiet=yes
884                 ;;
885         force*)                         # "force" prefix; always run
886                 rc_force=yes
887                 _rc_prefix=force
888                 rc_arg=${rc_arg#${_rc_prefix}}
889                 if [ -n "${rcvar}" ]; then
890                         eval ${rcvar}=YES
891                 fi
892                 ;;
893         one*)                           # "one" prefix; set ${rcvar}=yes
894                 _rc_prefix=one
895                 rc_arg=${rc_arg#${_rc_prefix}}
896                 if [ -n "${rcvar}" ]; then
897                         eval ${rcvar}=YES
898                 fi
899                 ;;
900         quiet*)                         # "quiet" prefix; omit some messages
901                 _rc_prefix=quiet
902                 rc_arg=${rc_arg#${_rc_prefix}}
903                 rc_quiet=yes
904                 ;;
905         esac
906
907         eval _override_command=\$${name}_program
908         command=${_override_command:-$command}
909
910         _keywords="start stop restart rcvar enabled $extra_commands"
911         rc_pid=
912         _pidcmd=
913         _procname=${procname:-${command}}
914
915                                         # setup pid check command
916         if [ -n "$_procname" ]; then
917                 if [ -n "$pidfile" ]; then
918                         _pidcmd='rc_pid=$(check_pidfile '"$pidfile $_procname $command_interpreter"')'
919                 else
920                         _pidcmd='rc_pid=$(check_process '"$_procname $command_interpreter"')'
921                 fi
922                 if [ -n "$_pidcmd" ]; then
923                         _keywords="${_keywords} status poll"
924                 fi
925         fi
926
927         if [ -z "$rc_arg" ]; then
928                 rc_usage $_keywords
929         fi
930
931         if [ "$rc_arg" = "enabled" ] ; then
932                 checkyesno ${rcvar}
933                 return $?
934         fi
935
936         if [ -n "$flags" ]; then        # allow override from environment
937                 rc_flags=$flags
938         else
939                 eval rc_flags=\$${name}_flags
940         fi
941         eval _chdir=\$${name}_chdir     _chroot=\$${name}_chroot \
942             _nice=\$${name}_nice        _user=\$${name}_user \
943             _group=\$${name}_group      _groups=\$${name}_groups \
944             _fib=\$${name}_fib          _env=\$${name}_env \
945             _prepend=\$${name}_prepend
946
947         if [ -n "$_user" ]; then        # unset $_user if running as that user
948                 if [ "$_user" = "$(eval $IDCMD)" ]; then
949                         unset _user
950                 fi
951         fi
952
953         [ -z "$autoboot" ] && eval $_pidcmd     # determine the pid if necessary
954
955         for _elem in $_keywords; do
956                 if [ "$_elem" != "$rc_arg" ]; then
957                         continue
958                 fi
959                                         # if ${rcvar} is set, $1 is not "rcvar"
960                                         # and ${rc_pid} is not set, then run
961                                         #       checkyesno ${rcvar}
962                                         # and return if that failed
963                                         #
964                 if [ -n "${rcvar}" -a "$rc_arg" != "rcvar" -a "$rc_arg" != "stop" ] ||
965                     [ -n "${rcvar}" -a "$rc_arg" = "stop" -a -z "${rc_pid}" ]; then
966                         if ! checkyesno ${rcvar}; then
967                                 if [ -n "${rc_quiet}" ]; then
968                                         return 0
969                                 fi
970                                 echo -n "Cannot '${rc_arg}' $name. Set ${rcvar} to "
971                                 echo -n "YES in /etc/rc.conf or use 'one${rc_arg}' "
972                                 echo "instead of '${rc_arg}'."
973                                 return 0
974                         fi
975                 fi
976
977                 if [ $rc_arg = "start" -a -z "$rc_fast" -a -n "$rc_pid" ]; then
978                         if [ -z "$rc_quiet" ]; then
979                                 echo 1>&2 "${name} already running? " \
980                                     "(pid=$rc_pid)."
981                         fi
982                         return 1
983                 fi
984
985                                         # if there's a custom ${XXX_cmd},
986                                         # run that instead of the default
987                                         #
988                 eval _cmd=\$${rc_arg}_cmd \
989                      _precmd=\$${rc_arg}_precmd \
990                      _postcmd=\$${rc_arg}_postcmd
991
992                 if [ -n "$_cmd" ]; then
993                         _run_rc_precmd || return 1
994                         _run_rc_doit "$_cmd $rc_extra_args" || return 1
995                         _run_rc_postcmd
996                         return $_return
997                 fi
998
999                 case "$rc_arg" in       # default operations...
1000
1001                 status)
1002                         _run_rc_precmd || return 1
1003                         if [ -n "$rc_pid" ]; then
1004                                 echo "${name} is running as pid $rc_pid."
1005                         else
1006                                 echo "${name} is not running."
1007                                 return 1
1008                         fi
1009                         _run_rc_postcmd
1010                         ;;
1011
1012                 start)
1013                         if [ ! -x "${_chroot}${_chroot:+/}${command}" ]; then
1014                                 warn "run_rc_command: cannot run $command"
1015                                 return 1
1016                         fi
1017
1018                         if ! _run_rc_precmd; then
1019                                 warn "failed precmd routine for ${name}"
1020                                 return 1
1021                         fi
1022
1023                                         # setup the full command to run
1024                                         #
1025                         check_startmsgs && echo "Starting ${name}."
1026                         if [ -n "$_chroot" ]; then
1027                                 _doit="\
1028 ${_nice:+nice -n $_nice }\
1029 ${_fib:+setfib -F $_fib }\
1030 ${_env:+env $_env }\
1031 chroot ${_user:+-u $_user }${_group:+-g $_group }${_groups:+-G $_groups }\
1032 $_chroot $command $rc_flags $command_args"
1033                         else
1034                                 _doit="\
1035 ${_chdir:+cd $_chdir && }\
1036 ${_fib:+setfib -F $_fib }\
1037 ${_env:+env $_env }\
1038 $command $rc_flags $command_args"
1039                                 if [ -n "$_user" ]; then
1040                                     _doit="su -m $_user -c 'sh -c \"$_doit\"'"
1041                                 fi
1042                                 if [ -n "$_nice" ]; then
1043                                         if [ -z "$_user" ]; then
1044                                                 _doit="sh -c \"$_doit\""
1045                                         fi
1046                                         _doit="nice -n $_nice $_doit"
1047                                 fi
1048                                 if [ -n "$_prepend" ]; then
1049                                         _doit="$_prepend $_doit"
1050                                 fi
1051                         fi
1052
1053                                         # run the full command
1054                                         #
1055                         if ! _run_rc_doit "$_doit"; then
1056                                 warn "failed to start ${name}"
1057                                 return 1
1058                         fi
1059
1060                                         # finally, run postcmd
1061                                         #
1062                         _run_rc_postcmd
1063                         ;;
1064
1065                 stop)
1066                         if [ -z "$rc_pid" ]; then
1067                                 [ -n "$rc_fast" ] && return 0
1068                                 _run_rc_notrunning
1069                                 return 1
1070                         fi
1071
1072                         _run_rc_precmd || return 1
1073
1074                                         # send the signal to stop
1075                                         #
1076                         echo "Stopping ${name}."
1077                         _doit=$(_run_rc_killcmd "${sig_stop:-TERM}")
1078                         _run_rc_doit "$_doit" || return 1
1079
1080                                         # wait for the command to exit,
1081                                         # and run postcmd.
1082                         wait_for_pids $rc_pid
1083
1084                         _run_rc_postcmd
1085                         ;;
1086
1087                 reload)
1088                         if [ -z "$rc_pid" ]; then
1089                                 _run_rc_notrunning
1090                                 return 1
1091                         fi
1092
1093                         _run_rc_precmd || return 1
1094
1095                         _doit=$(_run_rc_killcmd "${sig_reload:-HUP}")
1096                         _run_rc_doit "$_doit" || return 1
1097
1098                         _run_rc_postcmd
1099                         ;;
1100
1101                 restart)
1102                                         # prevent restart being called more
1103                                         # than once by any given script
1104                                         #
1105                         if ${_rc_restart_done:-false}; then
1106                                 return 0
1107                         fi
1108                         _rc_restart_done=true
1109
1110                         _run_rc_precmd || return 1
1111
1112                         # run those in a subshell to keep global variables
1113                         ( run_rc_command ${_rc_prefix}stop $rc_extra_args )
1114                         ( run_rc_command ${_rc_prefix}start $rc_extra_args )
1115                         _return=$?
1116                         [ $_return -ne 0 ] && [ -z "$rc_force" ] && return 1
1117
1118                         _run_rc_postcmd
1119                         ;;
1120
1121                 poll)
1122                         _run_rc_precmd || return 1
1123                         if [ -n "$rc_pid" ]; then
1124                                 wait_for_pids $rc_pid
1125                         fi
1126                         _run_rc_postcmd
1127                         ;;
1128
1129                 rcvar)
1130                         echo -n "# $name"
1131                         if [ -n "$desc" ]; then
1132                                 echo " : $desc"
1133                         else
1134                                 echo ""
1135                         fi
1136                         echo "#"
1137                         # Get unique vars in $rcvar $rcvars
1138                         for _v in $rcvar $rcvars; do
1139                                 case $v in
1140                                 $_v\ *|\ *$_v|*\ $_v\ *) ;;
1141                                 *)      v="${v# } $_v" ;;
1142                                 esac
1143                         done
1144
1145                         # Display variables.
1146                         for _v in $v; do
1147                                 if [ -z "$_v" ]; then
1148                                         continue
1149                                 fi
1150
1151                                 eval _desc=\$${_v}_desc
1152                                 eval _defval=\$${_v}_defval
1153                                 _h="-"
1154
1155                                 eval echo \"$_v=\\\"\$$_v\\\"\"
1156                                 # decode multiple lines of _desc
1157                                 while [ -n "$_desc" ]; do
1158                                         case $_desc in
1159                                         *^^*)
1160                                                 echo "# $_h ${_desc%%^^*}"
1161                                                 _desc=${_desc#*^^}
1162                                                 _h=" "
1163                                                 ;;
1164                                         *)
1165                                                 echo "# $_h ${_desc}"
1166                                                 break
1167                                                 ;;
1168                                         esac
1169                                 done
1170                                 echo "#   (default: \"$_defval\")"
1171                         done
1172                         echo ""
1173                         ;;
1174
1175                 *)
1176                         rc_usage $_keywords
1177                         ;;
1178
1179                 esac
1180                 return $_return
1181         done
1182
1183         echo 1>&2 "$0: unknown directive '$rc_arg'."
1184         rc_usage $_keywords
1185         # not reached
1186 }
1187
1188 #
1189 # Helper functions for run_rc_command: common code.
1190 # They use such global variables besides the exported rc_* ones:
1191 #
1192 #       name           R/W
1193 #       ------------------
1194 #       _precmd         R
1195 #       _postcmd        R
1196 #       _return         W
1197 #
1198 _run_rc_precmd()
1199 {
1200         check_required_before "$rc_arg" || return 1
1201
1202         if [ -n "$_precmd" ]; then
1203                 debug "run_rc_command: ${rc_arg}_precmd: $_precmd $rc_extra_args"
1204                 eval "$_precmd $rc_extra_args"
1205                 _return=$?
1206
1207                 # If precmd failed and force isn't set, request exit.
1208                 if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1209                         return 1
1210                 fi
1211         fi
1212
1213         check_required_after "$rc_arg" || return 1
1214
1215         return 0
1216 }
1217
1218 _run_rc_postcmd()
1219 {
1220         if [ -n "$_postcmd" ]; then
1221                 debug "run_rc_command: ${rc_arg}_postcmd: $_postcmd $rc_extra_args"
1222                 eval "$_postcmd $rc_extra_args"
1223                 _return=$?
1224         fi
1225         return 0
1226 }
1227
1228 _run_rc_doit()
1229 {
1230         debug "run_rc_command: doit: $*"
1231         eval "$@"
1232         _return=$?
1233
1234         # If command failed and force isn't set, request exit.
1235         if [ $_return -ne 0 ] && [ -z "$rc_force" ]; then
1236                 return 1
1237         fi
1238
1239         return 0
1240 }
1241
1242 _run_rc_notrunning()
1243 {
1244         local _pidmsg
1245
1246         if [ -n "$pidfile" ]; then
1247                 _pidmsg=" (check $pidfile)."
1248         else
1249                 _pidmsg=
1250         fi
1251         echo 1>&2 "${name} not running?${_pidmsg}"
1252 }
1253
1254 _run_rc_killcmd()
1255 {
1256         local _cmd
1257
1258         _cmd="kill -$1 $rc_pid"
1259         if [ -n "$_user" ]; then
1260                 _cmd="su -m ${_user} -c 'sh -c \"${_cmd}\"'"
1261         fi
1262         echo "$_cmd"
1263 }
1264
1265 #
1266 # run_rc_script file arg
1267 #       Start the script `file' with `arg', and correctly handle the
1268 #       return value from the script.
1269 #       If `file' ends with `.sh', it's sourced into the current environment
1270 #       when $rc_fast_and_loose is set, otherwise it is run as a child process.
1271 #       If `file' appears to be a backup or scratch file, ignore it.
1272 #       Otherwise if it is executable run as a child process.
1273 #
1274 run_rc_script()
1275 {
1276         _file=$1
1277         _arg=$2
1278         if [ -z "$_file" -o -z "$_arg" ]; then
1279                 err 3 'USAGE: run_rc_script file arg'
1280         fi
1281
1282         unset   name command command_args command_interpreter \
1283                 extra_commands pidfile procname \
1284                 rcvar rcvars rcvars_obsolete required_dirs required_files \
1285                 required_vars
1286         eval unset ${_arg}_cmd ${_arg}_precmd ${_arg}_postcmd
1287
1288         case "$_file" in
1289         /etc/rc.d/*.sh)                 # no longer allowed in the base
1290                 warn "Ignoring old-style startup script $_file"
1291                 ;;
1292         *[~#]|*.OLD|*.bak|*.orig|*,v)   # scratch file; skip
1293                 warn "Ignoring scratch file $_file"
1294                 ;;
1295         *)                              # run in subshell
1296                 if [ -x $_file ]; then
1297                         if [ -n "$rc_fast_and_loose" ]; then
1298                                 set $_arg; . $_file
1299                         else
1300                                 ( trap "echo Script $_file interrupted >&2 ; kill -QUIT $$" 3
1301                                   trap "echo Script $_file interrupted >&2 ; exit 1" 2
1302                                   trap "echo Script $_file running >&2" 29
1303                                   set $_arg; . $_file )
1304                         fi
1305                 fi
1306                 ;;
1307         esac
1308 }
1309
1310 #
1311 # load_rc_config [service]
1312 #       Source in the configuration file(s) for a given service.
1313 #       If no service is specified, only the global configuration
1314 #       file(s) will be loaded.
1315 #
1316 load_rc_config()
1317 {
1318         local _name _rcvar_val _var _defval _v _msg _new _d
1319         _name=$1
1320
1321         if ${_rc_conf_loaded:-false}; then
1322                 :
1323         else
1324                 if [ -r /etc/defaults/rc.conf ]; then
1325                         debug "Sourcing /etc/defaults/rc.conf"
1326                         . /etc/defaults/rc.conf
1327                         source_rc_confs
1328                 elif [ -r /etc/rc.conf ]; then
1329                         debug "Sourcing /etc/rc.conf (/etc/defaults/rc.conf doesn't exist)."
1330                         . /etc/rc.conf
1331                 fi
1332                 _rc_conf_loaded=true
1333         fi
1334
1335         # If a service name was specified, attempt to load
1336         # service-specific configuration
1337         if [ -n "$_name" ] ; then
1338                 for _d in /etc ${local_startup}; do
1339                         _d=${_d%/rc.d}
1340                         if [ -f ${_d}/rc.conf.d/"$_name" ]; then
1341                                 debug "Sourcing ${_d}/rc.conf.d/$_name"
1342                                 . ${_d}/rc.conf.d/"$_name"
1343                         elif [ -d ${_d}/rc.conf.d/"$_name" ] ; then
1344                                 local _rc
1345                                 for _rc in ${_d}/rc.conf.d/"$_name"/* ; do
1346                                         if [ -f "$_rc" ] ; then
1347                                                 debug "Sourcing $_rc"
1348                                                 . "$_rc"
1349                                         fi
1350                                 done
1351                         fi
1352                 done
1353         fi
1354
1355         # Set defaults if defined.
1356         for _var in $rcvar $rcvars; do
1357                 eval _defval=\$${_var}_defval
1358                 if [ -n "$_defval" ]; then
1359                         eval : \${$_var:=\$${_var}_defval}
1360                 fi
1361         done
1362
1363         # check obsolete rc.conf variables
1364         for _var in $rcvars_obsolete; do
1365                 eval _v=\$$_var
1366                 eval _msg=\$${_var}_obsolete_msg
1367                 eval _new=\$${_var}_newvar
1368                 case $_v in
1369                 "")
1370                         ;;
1371                 *)
1372                         if [ -z "$_new" ]; then
1373                                 _msg="Ignored."
1374                         else
1375                                 eval $_new=\"\$$_var\"
1376                                 if [ -z "$_msg" ]; then
1377                                         _msg="Use \$$_new instead."
1378                                 fi
1379                         fi
1380                         warn "\$$_var is obsolete.  $_msg"
1381                         ;;
1382                 esac
1383         done
1384 }
1385
1386 #
1387 # load_rc_config_var name var
1388 #       Read the rc.conf(5) var for name and set in the
1389 #       current shell, using load_rc_config in a subshell to prevent
1390 #       unwanted side effects from other variable assignments.
1391 #
1392 load_rc_config_var()
1393 {
1394         if [ $# -ne 2 ]; then
1395                 err 3 'USAGE: load_rc_config_var name var'
1396         fi
1397         eval $(eval '(
1398                 load_rc_config '$1' >/dev/null;
1399                 if [ -n "${'$2'}" -o "${'$2'-UNSET}" != "UNSET" ]; then
1400                         echo '$2'=\'\''${'$2'}\'\'';
1401                 fi
1402         )' )
1403 }
1404
1405 #
1406 # rc_usage commands
1407 #       Print a usage string for $0, with `commands' being a list of
1408 #       valid commands.
1409 #
1410 rc_usage()
1411 {
1412         echo -n 1>&2 "Usage: $0 [fast|force|one|quiet]("
1413
1414         _sep=
1415         for _elem; do
1416                 echo -n 1>&2 "$_sep$_elem"
1417                 _sep="|"
1418         done
1419         echo 1>&2 ")"
1420         exit 1
1421 }
1422
1423 #
1424 # err exitval message
1425 #       Display message to stderr and log to the syslog, and exit with exitval.
1426 #
1427 err()
1428 {
1429         exitval=$1
1430         shift
1431
1432         if [ -x /usr/bin/logger ]; then
1433                 logger "$0: ERROR: $*"
1434         fi
1435         echo 1>&2 "$0: ERROR: $*"
1436         exit $exitval
1437 }
1438
1439 #
1440 # warn message
1441 #       Display message to stderr and log to the syslog.
1442 #
1443 warn()
1444 {
1445         if [ -x /usr/bin/logger ]; then
1446                 logger "$0: WARNING: $*"
1447         fi
1448         echo 1>&2 "$0: WARNING: $*"
1449 }
1450
1451 #
1452 # info message
1453 #       Display informational message to stdout and log to syslog.
1454 #
1455 info()
1456 {
1457         case ${rc_info} in
1458         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1459                 if [ -x /usr/bin/logger ]; then
1460                         logger "$0: INFO: $*"
1461                 fi
1462                 echo "$0: INFO: $*"
1463                 ;;
1464         esac
1465 }
1466
1467 #
1468 # debug message
1469 #       If debugging is enabled in rc.conf output message to stderr.
1470 #       BEWARE that you don't call any subroutine that itself calls this
1471 #       function.
1472 #
1473 debug()
1474 {
1475         case ${rc_debug} in
1476         [Yy][Ee][Ss]|[Tt][Rr][Uu][Ee]|[Oo][Nn]|1)
1477                 if [ -x /usr/bin/logger ]; then
1478                         logger "$0: DEBUG: $*"
1479                 fi
1480                 echo 1>&2 "$0: DEBUG: $*"
1481                 ;;
1482         esac
1483 }
1484
1485 #
1486 # backup_file action file cur backup
1487 #       Make a backup copy of `file' into `cur', and save the previous
1488 #       version of `cur' as `backup' or use rcs for archiving.
1489 #
1490 #       This routine checks the value of the backup_uses_rcs variable,
1491 #       which can be either YES or NO.
1492 #
1493 #       The `action' keyword can be one of the following:
1494 #
1495 #       add             `file' is now being backed up (and is possibly
1496 #                       being reentered into the backups system).  `cur'
1497 #                       is created and RCS files, if necessary, are
1498 #                       created as well.
1499 #
1500 #       update          `file' has changed and needs to be backed up.
1501 #                       If `cur' exists, it is copied to to `back' or
1502 #                       checked into RCS (if the repository file is old),
1503 #                       and then `file' is copied to `cur'.  Another RCS
1504 #                       check in done here if RCS is being used.
1505 #
1506 #       remove          `file' is no longer being tracked by the backups
1507 #                       system.  If RCS is not being used, `cur' is moved
1508 #                       to `back', otherwise an empty file is checked in,
1509 #                       and then `cur' is removed.
1510 #
1511 #
1512 backup_file()
1513 {
1514         _action=$1
1515         _file=$2
1516         _cur=$3
1517         _back=$4
1518
1519         if checkyesno backup_uses_rcs; then
1520                 _msg0="backup archive"
1521                 _msg1="update"
1522
1523                 # ensure that history file is not locked
1524                 if [ -f $_cur,v ]; then
1525                         rcs -q -u -U -M $_cur
1526                 fi
1527
1528                 # ensure after switching to rcs that the
1529                 # current backup is not lost
1530                 if [ -f $_cur ]; then
1531                         # no archive, or current newer than archive
1532                         if [ ! -f $_cur,v -o $_cur -nt $_cur,v ]; then
1533                                 ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1534                                 rcs -q -kb -U $_cur
1535                                 co -q -f -u $_cur
1536                         fi
1537                 fi
1538
1539                 case $_action in
1540                 add|update)
1541                         cp -p $_file $_cur
1542                         ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1543                         rcs -q -kb -U $_cur
1544                         co -q -f -u $_cur
1545                         chown root:wheel $_cur $_cur,v
1546                         ;;
1547                 remove)
1548                         cp /dev/null $_cur
1549                         ci -q -f -u -t-"$_msg0" -m"$_msg1" $_cur
1550                         rcs -q -kb -U $_cur
1551                         chown root:wheel $_cur $_cur,v
1552                         rm $_cur
1553                         ;;
1554                 esac
1555         else
1556                 case $_action in
1557                 add|update)
1558                         if [ -f $_cur ]; then
1559                                 cp -p $_cur $_back
1560                         fi
1561                         cp -p $_file $_cur
1562                         chown root:wheel $_cur
1563                         ;;
1564                 remove)
1565                         mv -f $_cur $_back
1566                         ;;
1567                 esac
1568         fi
1569 }
1570
1571 # make_symlink src link
1572 #       Make a symbolic link 'link' to src from basedir. If the
1573 #       directory in which link is to be created does not exist
1574 #       a warning will be displayed and an error will be returned.
1575 #       Returns 0 on success, 1 otherwise.
1576 #
1577 make_symlink()
1578 {
1579         local src link linkdir _me
1580         src="$1"
1581         link="$2"
1582         linkdir="`dirname $link`"
1583         _me="make_symlink()"
1584
1585         if [ -z "$src" -o -z "$link" ]; then
1586                 warn "$_me: requires two arguments."
1587                 return 1
1588         fi
1589         if [ ! -d "$linkdir" ]; then
1590                 warn "$_me: the directory $linkdir does not exist."
1591                 return 1
1592         fi
1593         if ! ln -sf $src $link; then
1594                 warn "$_me: unable to make a symbolic link from $link to $src"
1595                 return 1
1596         fi
1597         return 0
1598 }
1599
1600 # devfs_rulesets_from_file file
1601 #       Reads a set of devfs commands from file, and creates
1602 #       the specified rulesets with their rules. Returns non-zero
1603 #       if there was an error.
1604 #
1605 devfs_rulesets_from_file()
1606 {
1607         local file _err _me _opts
1608         file="$1"
1609         _me="devfs_rulesets_from_file"
1610         _err=0
1611
1612         if [ -z "$file" ]; then
1613                 warn "$_me: you must specify a file"
1614                 return 1
1615         fi
1616         if [ ! -e "$file" ]; then
1617                 debug "$_me: no such file ($file)"
1618                 return 0
1619         fi
1620
1621         # Disable globbing so that the rule patterns are not expanded
1622         # by accident with matching filesystem entries.
1623         _opts=$-; set -f
1624
1625         debug "reading rulesets from file ($file)"
1626         { while read line
1627         do
1628                 case $line in
1629                 \#*)
1630                         continue
1631                         ;;
1632                 \[*\]*)
1633                         rulenum=`expr "$line" : "\[.*=\([0-9]*\)\]"`
1634                         if [ -z "$rulenum" ]; then
1635                                 warn "$_me: cannot extract rule number ($line)"
1636                                 _err=1
1637                                 break
1638                         fi
1639                         rulename=`expr "$line" : "\[\(.*\)=[0-9]*\]"`
1640                         if [ -z "$rulename" ]; then
1641                                 warn "$_me: cannot extract rule name ($line)"
1642                                 _err=1
1643                                 break;
1644                         fi
1645                         eval $rulename=\$rulenum
1646                         debug "found ruleset: $rulename=$rulenum"
1647                         if ! /sbin/devfs rule -s $rulenum delset; then
1648                                 _err=1
1649                                 break
1650                         fi
1651                         ;;
1652                 *)
1653                         rulecmd="${line%%"\#*"}"
1654                         # evaluate the command incase it includes
1655                         # other rules
1656                         if [ -n "$rulecmd" ]; then
1657                                 debug "adding rule ($rulecmd)"
1658                                 if ! eval /sbin/devfs rule -s $rulenum $rulecmd
1659                                 then
1660                                         _err=1
1661                                         break
1662                                 fi
1663                         fi
1664                         ;;
1665                 esac
1666                 if [ $_err -ne 0 ]; then
1667                         debug "error in $_me"
1668                         break
1669                 fi
1670         done } < $file
1671         case $_opts in *f*) ;; *) set +f ;; esac
1672         return $_err
1673 }
1674
1675 # devfs_init_rulesets
1676 #       Initializes rulesets from configuration files. Returns
1677 #       non-zero if there was an error.
1678 #
1679 devfs_init_rulesets()
1680 {
1681         local file _me
1682         _me="devfs_init_rulesets"
1683
1684         # Go through this only once
1685         if [ -n "$devfs_rulesets_init" ]; then
1686                 debug "$_me: devfs rulesets already initialized"
1687                 return
1688         fi
1689         for file in $devfs_rulesets; do
1690                 if ! devfs_rulesets_from_file $file; then
1691                         warn "$_me: could not read rules from $file"
1692                         return 1
1693                 fi
1694         done
1695         devfs_rulesets_init=1
1696         debug "$_me: devfs rulesets initialized"
1697         return 0
1698 }
1699
1700 # devfs_set_ruleset ruleset [dir]
1701 #       Sets the default ruleset of dir to ruleset. The ruleset argument
1702 #       must be a ruleset name as specified in devfs.rules(5) file.
1703 #       Returns non-zero if it could not set it successfully.
1704 #
1705 devfs_set_ruleset()
1706 {
1707         local devdir rs _me
1708         [ -n "$1" ] && eval rs=\$$1 || rs=
1709         [ -n "$2" ] && devdir="-m "$2"" || devdir=
1710         _me="devfs_set_ruleset"
1711
1712         if [ -z "$rs" ]; then
1713                 warn "$_me: you must specify a ruleset number"
1714                 return 1
1715         fi
1716         debug "$_me: setting ruleset ($rs) on mount-point (${devdir#-m })"
1717         if ! /sbin/devfs $devdir ruleset $rs; then
1718                 warn "$_me: unable to set ruleset $rs to ${devdir#-m }"
1719                 return 1
1720         fi
1721         return 0
1722 }
1723
1724 # devfs_apply_ruleset ruleset [dir]
1725 #       Apply ruleset number $ruleset to the devfs mountpoint $dir.
1726 #       The ruleset argument must be a ruleset name as specified
1727 #       in a devfs.rules(5) file.  Returns 0 on success or non-zero
1728 #       if it could not apply the ruleset.
1729 #
1730 devfs_apply_ruleset()
1731 {
1732         local devdir rs _me
1733         [ -n "$1" ] && eval rs=\$$1 || rs=
1734         [ -n "$2" ] && devdir="-m "$2"" || devdir=
1735         _me="devfs_apply_ruleset"
1736
1737         if [ -z "$rs" ]; then
1738                 warn "$_me: you must specify a ruleset"
1739                 return 1
1740         fi
1741         debug "$_me: applying ruleset ($rs) to mount-point (${devdir#-m })"
1742         if ! /sbin/devfs $devdir rule -s $rs applyset; then
1743                 warn "$_me: unable to apply ruleset $rs to ${devdir#-m }"
1744                 return 1
1745         fi
1746         return 0
1747 }
1748
1749 # devfs_domount dir [ruleset]
1750 #       Mount devfs on dir. If ruleset is specified it is set
1751 #       on the mount-point. It must also be a ruleset name as specified
1752 #       in a devfs.rules(5) file. Returns 0 on success.
1753 #
1754 devfs_domount()
1755 {
1756         local devdir rs _me
1757         devdir="$1"
1758         [ -n "$2" ] && rs=$2 || rs=
1759         _me="devfs_domount()"
1760
1761         if [ -z "$devdir" ]; then
1762                 warn "$_me: you must specify a mount-point"
1763                 return 1
1764         fi
1765         debug "$_me: mount-point is ($devdir), ruleset is ($rs)"
1766         if ! mount -t devfs dev "$devdir"; then
1767                 warn "$_me: Unable to mount devfs on $devdir"
1768                 return 1
1769         fi
1770         if [ -n "$rs" ]; then
1771                 devfs_init_rulesets
1772                 devfs_set_ruleset $rs $devdir
1773                 devfs -m $devdir rule applyset
1774         fi
1775         return 0
1776 }
1777
1778 # Provide a function for normalizing the mounting of memory
1779 # filesystems.  This should allow the rest of the code here to remain
1780 # as close as possible between 5-current and 4-stable.
1781 #   $1 = size
1782 #   $2 = mount point
1783 #   $3 = (optional) extra mdmfs flags
1784 mount_md()
1785 {
1786         if [ -n "$3" ]; then
1787                 flags="$3"
1788         fi
1789         /sbin/mdmfs $flags -s $1 md $2
1790 }
1791
1792 # Code common to scripts that need to load a kernel module
1793 # if it isn't in the kernel yet. Syntax:
1794 #   load_kld [-e regex] [-m module] file
1795 # where -e or -m chooses the way to check if the module
1796 # is already loaded:
1797 #   regex is egrep'd in the output from `kldstat -v',
1798 #   module is passed to `kldstat -m'.
1799 # The default way is as though `-m file' were specified.
1800 load_kld()
1801 {
1802         local _loaded _mod _opt _re
1803
1804         while getopts "e:m:" _opt; do
1805                 case "$_opt" in
1806                 e) _re="$OPTARG" ;;
1807                 m) _mod="$OPTARG" ;;
1808                 *) err 3 'USAGE: load_kld [-e regex] [-m module] file' ;;
1809                 esac
1810         done
1811         shift $(($OPTIND - 1))
1812         if [ $# -ne 1 ]; then
1813                 err 3 'USAGE: load_kld [-e regex] [-m module] file'
1814         fi
1815         _mod=${_mod:-$1}
1816         _loaded=false
1817         if [ -n "$_re" ]; then
1818                 if kldstat -v | egrep -q -e "$_re"; then
1819                         _loaded=true
1820                 fi
1821         else
1822                 if kldstat -q -m "$_mod"; then
1823                         _loaded=true
1824                 fi
1825         fi
1826         if ! $_loaded; then
1827                 if ! kldload "$1"; then
1828                         warn "Unable to load kernel module $1"
1829                         return 1
1830                 else
1831                         info "$1 kernel module loaded."
1832                 fi
1833         else
1834                 debug "load_kld: $1 kernel module already loaded."
1835         fi
1836         return 0
1837 }
1838
1839 # ltr str src dst [var]
1840 #       Change every $src in $str to $dst.
1841 #       Useful when /usr is not yet mounted and we cannot use tr(1), sed(1) nor
1842 #       awk(1). If var is non-NULL, set it to the result.
1843 ltr()
1844 {
1845         local _str _src _dst _out _com _var
1846         _str="$1"
1847         _src="$2"
1848         _dst="$3"
1849         _var="$4"
1850         _out=""
1851
1852         local IFS="${_src}"
1853         for _com in ${_str}; do
1854                 if [ -z "${_out}" ]; then
1855                         _out="${_com}"
1856                 else
1857                         _out="${_out}${_dst}${_com}"
1858                 fi
1859         done
1860         if [ -n "${_var}" ]; then
1861                 setvar "${_var}" "${_out}"
1862         else
1863                 echo "${_out}"
1864         fi
1865 }
1866
1867 # Creates a list of providers for GELI encryption.
1868 geli_make_list()
1869 {
1870         local devices devices2
1871         local provider mountpoint type options rest
1872
1873         # Create list of GELI providers from fstab.
1874         while read provider mountpoint type options rest ; do
1875                 case ":${options}" in
1876                 :*noauto*)
1877                         noauto=yes
1878                         ;;
1879                 *)
1880                         noauto=no
1881                         ;;
1882                 esac
1883
1884                 case ":${provider}" in
1885                 :#*)
1886                         continue
1887                         ;;
1888                 *.eli)
1889                         # Skip swap devices.
1890                         if [ "${type}" = "swap" -o "${options}" = "sw" -o "${noauto}" = "yes" ]; then
1891                                 continue
1892                         fi
1893                         devices="${devices} ${provider}"
1894                         ;;
1895                 esac
1896         done < /etc/fstab
1897
1898         # Append providers from geli_devices.
1899         devices="${devices} ${geli_devices}"
1900
1901         for provider in ${devices}; do
1902                 provider=${provider%.eli}
1903                 provider=${provider#/dev/}
1904                 devices2="${devices2} ${provider}"
1905         done
1906
1907         echo ${devices2}
1908 }
1909
1910 # Find scripts in local_startup directories that use the old syntax
1911 #
1912 find_local_scripts_old() {
1913         zlist=''
1914         slist=''
1915         for dir in ${local_startup}; do
1916                 if [ -d "${dir}" ]; then
1917                         for file in ${dir}/[0-9]*.sh; do
1918                                 grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1919                                     continue
1920                                 zlist="$zlist $file"
1921                         done
1922                         for file in ${dir}/[!0-9]*.sh; do
1923                                 grep '^# PROVIDE:' $file >/dev/null 2>&1 &&
1924                                     continue
1925                                 slist="$slist $file"
1926                         done
1927                 fi
1928         done
1929 }
1930
1931 find_local_scripts_new() {
1932         local_rc=''
1933         for dir in ${local_startup}; do
1934                 if [ -d "${dir}" ]; then
1935                         for file in `grep -l '^# PROVIDE:' ${dir}/* 2>/dev/null`; do
1936                                 case "$file" in
1937                                 *.sample) ;;
1938                                 *)      if [ -x "$file" ]; then
1939                                                 local_rc="${local_rc} ${file}"
1940                                         fi
1941                                         ;;
1942                                 esac
1943                         done
1944                 fi
1945         done
1946 }
1947
1948 # check_required_{before|after} command
1949 #       Check for things required by the command before and after its precmd,
1950 #       respectively.  The two separate functions are needed because some
1951 #       conditions should prevent precmd from being run while other things
1952 #       depend on precmd having already been run.
1953 #
1954 check_required_before()
1955 {
1956         local _f
1957
1958         case "$1" in
1959         start)
1960                 for _f in $required_vars; do
1961                         if ! checkyesno $_f; then
1962                                 warn "\$${_f} is not enabled."
1963                                 if [ -z "$rc_force" ]; then
1964                                         return 1
1965                                 fi
1966                         fi
1967                 done
1968
1969                 for _f in $required_dirs; do
1970                         if [ ! -d "${_f}/." ]; then
1971                                 warn "${_f} is not a directory."
1972                                 if [ -z "$rc_force" ]; then
1973                                         return 1
1974                                 fi
1975                         fi
1976                 done
1977
1978                 for _f in $required_files; do
1979                         if [ ! -r "${_f}" ]; then
1980                                 warn "${_f} is not readable."
1981                                 if [ -z "$rc_force" ]; then
1982                                         return 1
1983                                 fi
1984                         fi
1985                 done
1986                 ;;
1987         esac
1988
1989         return 0
1990 }
1991
1992 check_required_after()
1993 {
1994         local _f _args
1995
1996         case "$1" in
1997         start)
1998                 for _f in $required_modules; do
1999                         case "${_f}" in
2000                                 *~*)    _args="-e ${_f#*~} ${_f%%~*}" ;;
2001                                 *:*)    _args="-m ${_f#*:} ${_f%%:*}" ;;
2002                                 *)      _args="${_f}" ;;
2003                         esac
2004                         if ! load_kld ${_args}; then
2005                                 if [ -z "$rc_force" ]; then
2006                                         return 1
2007                                 fi
2008                         fi
2009                 done
2010                 ;;
2011         esac
2012
2013         return 0
2014 }
2015
2016 # check_jail mib
2017 #       Return true if security.jail.$mib exists and set to 1.
2018
2019 check_jail()
2020 {
2021         local _mib _v
2022
2023         _mib=$1
2024         if _v=$(${SYSCTL_N} "security.jail.$_mib" 2> /dev/null); then
2025                 case $_v in
2026                 1)      return 0;;
2027                 esac
2028         fi
2029         return 1
2030 }
2031
2032 # check_kern_features mib
2033 #       Return existence of kern.features.* sysctl MIB as true or
2034 #       false.  The result will be cached in $_rc_cache_kern_features_
2035 #       namespace.  "0" means the kern.features.X exists.
2036
2037 check_kern_features()
2038 {
2039         local _v
2040
2041         [ -n "$1" ] || return 1;
2042         eval _v=\$_rc_cache_kern_features_$1
2043         [ -n "$_v" ] && return "$_v";
2044
2045         if ${SYSCTL_N} kern.features.$1 > /dev/null 2>&1; then
2046                 eval _rc_cache_kern_features_$1=0
2047                 return 0
2048         else
2049                 eval _rc_cache_kern_features_$1=1
2050                 return 1
2051         fi
2052 }
2053
2054 # check_namevarlist var
2055 #       Return "0" if ${name}_var is reserved in rc.subr.
2056
2057 _rc_namevarlist="program chroot chdir env flags fib nice user group groups prepend"
2058 check_namevarlist()
2059 {
2060         local _v
2061
2062         for _v in $_rc_namevarlist; do
2063         case $1 in
2064         $_v)    return 0 ;;
2065         esac
2066         done
2067
2068         return 1
2069 }
2070
2071 # _echoonce var msg mode
2072 #       mode=0: Echo $msg if ${$var} is empty.
2073 #               After doing echo, a string is set to ${$var}.
2074 #
2075 #       mode=1: Echo $msg if ${$var} is a string with non-zero length.
2076 #
2077 _echoonce()
2078 {
2079         local _var _msg _mode
2080         eval _var=\$$1
2081         _msg=$2
2082         _mode=$3
2083
2084         case $_mode in
2085         1)      [ -n "$_var" ] && echo "$_msg" ;;
2086         *)      [ -z "$_var" ] && echo -n "$_msg" && eval "$1=finished" ;;
2087         esac
2088 }
2089
2090 fi # [ -z "${_rc_subr_loaded}" ]
2091
2092 _rc_subr_loaded=: